moSetGetSlotObjects = {};

function moSetGetSlotObjects:setUpdate(self, slot, slotName)	
	local oldFoundObjects = moGuiMiniPdaSlots.values[slot].foundObjects;
	moGuiMiniPdaSlots.values[slot].foundObjects = 0;
	moGuiMiniPdaSlots.values[slot].foundObjectsNamen = "";
	moGuiMiniPdaSlots.values[slot].productivity = 100;
	moGuiMiniPdaSlots.values[slot].objects = {};	
	--print("update slot.........".. tostring(slotName))
	local tableToClass = {};
	moSetGetSlotObjects:getPlaceables(self, tableToClass);
	function checkMapObject(modType, xmlModString, category, separated, objectName, displayName, slotEdit, isHiden)		
		if moMapObjects[modType][1] == nil then return;end;
		for a=1, table.getn(moMapObjects[modType]) do
			if string.lower(moMapObjects[modType][a].name) == xmlModString then				
				local replaceDisplayName = displayName;
				if not string.find(moGeneralSettings.setSlotFabrikscript, xmlModString.. " ") then moGeneralSettings.setSlotFabrikscript = moGeneralSettings.setSlotFabrikscript.. xmlModString.. " ";end;
				--if moMapObjects[modType][a].name ~= xmlModString and moMapObjects[modType][a].factoryName ~= nil and xmlModString ~= string.lower(moMapObjects[modType][a].factoryName) then replaceDisplayName = moMapObjects[modType][a].factoryName;end;
				if not isHiden then
					setObject(self, modType, moMapObjects[modType][a], category, separated, objectName, replaceDisplayName, slot, slotName, false, xmlModString, moMapObjects[modType][a].x, moMapObjects[modType][a].z, slotEdit, xmlModString);
				end;				
			end;
		end;
	end;
	function checkMapHeaps(modType, xmlModString, category, separated, objectName, displayName, slotEdit, isHiden)		
		if g_currentMission.heapPreview == nil or #g_currentMission.heapPreview == 0 then return;end;
		for a=1, #g_currentMission.heapPreview do							
			if g_currentMission.heapPreview[a] ~= nil then
				local replaceDisplayName = displayName;
				if not string.find(moGeneralSettings.setSlotFabrikscript, xmlModString.. " ") then moGeneralSettings.setSlotFabrikscript = moGeneralSettings.setSlotFabrikscript.. xmlModString.. " ";end;
				--if moMapObjects[modType][a].name ~= xmlModString and moMapObjects[modType][a].factoryName ~= nil and xmlModString ~= string.lower(moMapObjects[modType][a].factoryName) then replaceDisplayName = moMapObjects[modType][a].factoryName;end;
				if not isHiden then
					setObject(self, modType, g_currentMission.heapPreview[a], category, separated, objectName, replaceDisplayName, slot, slotName, false, xmlModString, g_currentMission.heapPreview[a].px, g_currentMission.heapPreview[a].pz, slotEdit, xmlModString);
				end;
			end;			
		end;
	end;
	if moObjectsMap[slotName.. "Found"] > 0 then
		for a=1, moObjectsMap[slotName.. "Found"] do		
			if moObjectsMap[slotName][a] ~= nil then
				local splitString = Utils.splitString(",", moObjectsMap[slotName][a]);
				local modType = splitString[1];
				local xmlModString = string.lower(splitString[2]);
				local category = Utils.getNoNil(splitString[3], "factory");
				local separated = false;
				local isHiden = false;
				if Utils.getNoNil(splitString[4], "false") == "true" then separated = true;end;
				if Utils.getNoNil(splitString[5], "false") == "true" then isHiden = true;end;
				local displayName = Utils.getNoNil(splitString[6], moLanguageXml:getTxt("factory", nil, "Factory".. a));				 
				if modType == "upk" and moGeneralSettings.upkReady or modType ~= "upk" then	
					local replaceDisplayName = string.gsub(displayName, " ", "_");					
					if modType == "ls" and xmlModString == "heaps" then
						checkMapHeaps(modType, xmlModString, category, separated, replaceDisplayName.. "_".. modType, displayName, true, isHiden);
					else
						checkMapObject(modType, xmlModString, category, separated, replaceDisplayName.. "_".. modType, displayName, true, isHiden);
					end;					
				end;
			end;
		end;
	end;
	if slotName == "animals" and not moGuiMiniPdaSlots.onlyObjectSettings then
		if moMapObjects["sr"][1] ~= nil then
			for a=1, table.getn(moMapObjects["sr"]) do
				if not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["sr"][a].name).. " ") then				
					local displayName = moMapObjects["sr"][a].name;				
					setObject(self, "sr", moMapObjects["sr"][a], "animals", true, "animals_sr", displayName, slot, slotName, false, "animals", moMapObjects["sr"][a].x, moMapObjects["sr"][a].z, true, displayName);				
				end;
			end;
		end;
		if moMapObjects["ls"][1] ~= nil then
			for a=1, table.getn(moMapObjects["ls"]) do
				if not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["ls"][a].name).. " ") then				
					local displayName = moMapObjects["ls"][a].name;				
					setObject(self, "ls", moMapObjects["ls"][a], "animals", true, "animals_ls", displayName, slot, slotName, false, "animals", moMapObjects["ls"][a].x, moMapObjects["ls"][a].z, true, displayName);				
				end;
			end;
		end;
	end;
	if slotName == "other1" and not moGuiMiniPdaSlots.onlyObjectSettings then
		if moMapObjects["fs"][1] ~= nil then
			for a=1, table.getn(moMapObjects["fs"]) do
				if moMapObjects["fs"][a].name == "factory" or not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["fs"][a].name).. " ") then				
					local userAttribut = false;
					if moMapObjects["fs"][a].userAttribut ~= nil and moMapObjects["fs"][a].userAttribut then userAttribut = true;end;
					local displayName = moMapObjects["fs"][a].name;
					if moMapObjects["fs"][a].name == "factory" then displayName = tostring(moLanguageXml:getTxt("factory", nil, "Factory"));end;
					--if moMapObjects["fs"][a].factoryName ~= nil then displayName = moMapObjects["fs"][a].factoryName ;end;
					setObject(self, "fs", moMapObjects["fs"][a], "factory", true, "factory_fs", displayName, slot, slotName, false, "factory", moMapObjects["fs"][a].x, moMapObjects["fs"][a].z, userAttribut, displayName);				
				end;
			end;
		end;
		if moMapObjects["cf"][1] ~= nil then
			for a=1, table.getn(moMapObjects["cf"]) do
				if moMapObjects["cf"][a].name == "factory" or not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["cf"][a].name).. " ") then				
					local userAttribut = false;
					if moMapObjects["cf"][a].userAttribut ~= nil and moMapObjects["cf"][a].userAttribut then userAttribut = true;end;
					local displayName = moMapObjects["cf"][a].name;
					if moMapObjects["cf"][a].name == "factory" then displayName = tostring(moLanguageXml:getTxt("factory", nil, "Factory"));end;
					--if moMapObjects["fs"][a].factoryName ~= nil then displayName = moMapObjects["fs"][a].factoryName ;end;
					setObject(self, "cf", moMapObjects["cf"][a], "factory", true, "factory_cf", displayName, slot, slotName, false, "factory", moMapObjects["cf"][a].x, moMapObjects["cf"][a].z, userAttribut, displayName);				
				end;
			end;
		end;
	end;
	if slotName == "factory1" and not moGuiMiniPdaSlots.onlyObjectSettings then
		if moMapObjects["other"][1] == nil then return;end;
		for a=1, table.getn(moMapObjects["other"]) do
			if not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["other"][a].name).. " ") then				
				local userAttribut = false;
				if moMapObjects["other"][a].userAttribut ~= nil and moMapObjects["other"][a].userAttribut then userAttribut = true;end;
				local displayName = moMapObjects["other"][a].name;
				--if moMapObjects["other"][a].name == "other" then displayName = tostring(moLanguageXml:getTxt("factory", nil, "Factory"));end;
				--if moMapObjects["fs"][a].factoryName ~= nil then displayName = moMapObjects["fs"][a].factoryName ;end;
				setObject(self, "other", moMapObjects["other"][a], "factory", true, "factory_other", displayName, slot, slotName, false, "factory", moMapObjects["other"][a].x, moMapObjects["other"][a].z, userAttribut, displayName);				
			end;
		end;
	end;
	function checkPlaceableObject(modType, xmlModString, category, separated, objectName, displayName, realXmlModString, slotEdit)		
		if xmlModString ~= nil then			
			setObject(self, modType, xmlModString, category, separated, objectName, displayName, slot, slotName, true, nil, nil, nil, slotEdit, realXmlModString);
		elseif category == "heaps" and string.find(realXmlModString, "heaptiptrigger") then
			setObject(self, modType, xmlModString, category, separated, objectName, displayName, slot, slotName, true, realXmlModString, nil, nil, slotEdit, realXmlModString);		
		--elseif string.find(realXmlModString, "data/placeables/greenhouses/") or string.find(realXmlModString, "data/placeables/siloextensions/") then --ls17
		--	setObject(self, modType, xmlModString, category, separated, objectName, displayName, slot, slotName, true, realXmlModString, nil, nil, slotEdit, realXmlModString);
		elseif #tableToClass > 0 then
			setObject(self, modType, tableToClass, category, separated, objectName, displayName, slot, slotName, true, realXmlModString, nil, nil, slotEdit, realXmlModString);
		end;
	end;
	if moObjectsPlaceable[slotName.. "Found"] > 0 then
		for a=1, moObjectsPlaceable[slotName.. "Found"] do		
			if moObjectsPlaceable[slotName][a] ~= nil then				
				local splitString = Utils.splitString(",", moObjectsPlaceable[slotName][a]);
				local modType = splitString[1];			
				local xmlModString = string.lower(MultiOverlayV2.gameDir.. splitString[2]);
				if modType == "ls" then xmlModString = string.lower(splitString[2]);end;
				local category = Utils.getNoNil(splitString[3], "factory");
				local separated = false;
				local isHiden = false;
				if Utils.getNoNil(splitString[4], "false") == "true" then separated = true;end;
				if Utils.getNoNil(splitString[5], "false") == "true" then isHiden = true;end;
				local displayName = Utils.getNoNil(splitString[6], "factory".. a);
				if modType == "upk" and moGeneralSettings.upkReady or modType ~= "upk" then				
					local replaceDisplayName = string.gsub(displayName, " ", "_");					
					if not isHiden then
						checkPlaceableObject(modType, g_currentMission.placeables[xmlModString], category, separated, replaceDisplayName.. "_".. modType, displayName, xmlModString, true);						
					end;
				end;
			end;
		end;
	end;
	table.remove(tableToClass)	
	--if oldFoundObjects ~= moGuiMiniPdaSlots.values[slot].foundObjects then moGuiExtras:setSlotMaxProSwitch(self, slot);end;
	--if slotName == "stocks1" then print(tostring(MultiOverlayV2:tableToString(moGuiMiniPdaSlots.values[slot].objects)));end;
end;

function setObject(self, modType, objectTable, category, separated, objectName, displayName, slot, slotName, placeable, xmlModString, mapX, mapZ, slotEdit, slotEditXmlString)	
	local inputFillTypes; 
	local outputFillTypes;
	local slotTableObject;	
	function setObjectTable(objectName, x, z)
		moGuiMiniPdaSlots.values[slot].foundObjects = moGuiMiniPdaSlots.values[slot].foundObjects+1;
		if string.len(moGuiMiniPdaSlots.values[slot].foundObjectsNamen) > 0 then
			moGuiMiniPdaSlots.values[slot].foundObjectsNamen = moGuiMiniPdaSlots.values[slot].foundObjectsNamen.. " ".. objectName;
		else
			moGuiMiniPdaSlots.values[slot].foundObjectsNamen = objectName;
		end;
		moGuiMiniPdaSlots.values[slot].objects[objectName] = {};
		slotTableObject = moGuiMiniPdaSlots.values[slot].objects[objectName];		
		if not placeable and mapX ~= nil and mapZ ~= nil then
			moGuiMiniPdaSlots.values[slot].objects[objectName].x = mapX;
			moGuiMiniPdaSlots.values[slot].objects[objectName].z = mapZ;
		else
			moGuiMiniPdaSlots.values[slot].objects[objectName].x = x;
			moGuiMiniPdaSlots.values[slot].objects[objectName].z = z;
		end;
		moGuiMiniPdaSlots.values[slot].objects[objectName].category = category;
		moGuiMiniPdaSlots.values[slot].objects[objectName].modType = modType;
		moGuiMiniPdaSlots.values[slot].objects[objectName].inputFillTypes = {};
		moGuiMiniPdaSlots.values[slot].objects[objectName].outputFillTypes = {};		
		moGuiMiniPdaSlots.values[slot].objects[objectName].special = false;			
		moGuiMiniPdaSlots.values[slot].objects[objectName].length = 1;
		moGuiMiniPdaSlots.values[slot].objects[objectName].lengthActive = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].lengthNotActive = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].productivity = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].productivityColor = moGuiMiniPdaSlots.warningColor4;		
		moGuiMiniPdaSlots.values[slot].objects[objectName].displayName = displayName;
		moGuiMiniPdaSlots.values[slot].objects[objectName].slotEdit = slotEdit;
		moGuiMiniPdaSlots.values[slot].objects[objectName].separated = separated;
		moGuiMiniPdaSlots.values[slot].objects[objectName].placeable = placeable;
		moGuiMiniPdaSlots.values[slot].objects[objectName].xmlModString = slotEditXmlString;
	end;	
	local fillLevelFound = false;
	local separatedProductivity = false;
	local outputFillLevelIgnore = false;
	function setGetInputOutputFillTypes(specialTable, x, z)			
		if inputFillTypes == nil and outputFillTypes == nil or table.getn(inputFillTypes) == 0 and table.getn(outputFillTypes) == 0 then 
			return;		
		end;
		if moGuiMiniPdaSlots.values[slot].objects[objectName] == nil then 			
			setObjectTable(objectName, x ,z);			
		elseif separated then
			setObjectTable(objectName.. "_".. moGuiMiniPdaSlots.values[slot].foundObjects, x, z);
		else
			slotTableObject = moGuiMiniPdaSlots.values[slot].objects[objectName];
			slotTableObject.length = slotTableObject.length+1;
		end;
		if not specialTable and outputFillTypes ~= nil and table.getn(outputFillTypes) > 0 then
			for container,info in pairs(outputFillTypes) do					
				if slotTableObject.outputFillTypes[container] == nil then
					slotTableObject.outputFillTypes[container] = {};						
					slotTableObject.outputFillTypes[container].capacity = outputFillTypes[container][1].capacity;
					slotTableObject.outputFillTypes[container].fillLevel = outputFillTypes[container][1].fillLevel;
					slotTableObject.outputFillTypes[container].bestPrice = outputFillTypes[container][1].pricePerLiter;
					slotTableObject.outputFillTypes[container].fillTypeName = outputFillTypes[container][1].fillTypeName;					
					slotTableObject.outputFillTypes[container].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes;
					if outputFillTypes[container][1].setColor ~= nil then 
						slotTableObject.outputFillTypes[container].setColor = outputFillTypes[container][1].setColor;						
					end;
					
					if outputFillTypes[container][1].extraText ~= nil then slotTableObject.outputFillTypes[container].extraText = outputFillTypes[container][1].extraText;end;
					if outputFillTypes[container][1].fillTypeContainerName ~= nil then slotTableObject.outputFillTypes[container].fillTypeContainerName = outputFillTypes[container][1].fillTypeContainerName;end;
				else
					if outputFillTypes[container][1].capacity ~= -1 and outputFillTypes[container][1].capacity ~= -2 and outputFillTypes[container][1].capacity ~= -3 then
						slotTableObject.outputFillTypes[container].capacity = slotTableObject.outputFillTypes[container].capacity+outputFillTypes[container][1].capacity;
					elseif outputFillTypes[container][1].capacity ~= -2 or outputFillTypes[container][1].capacity ~= -3 then						
						slotTableObject.outputFillTypes[container].bestPrice = slotTableObject.outputFillTypes[container].bestPrice+outputFillTypes[container][1].pricePerLiter;
					end;
					slotTableObject.outputFillTypes[container].fillLevel = slotTableObject.outputFillTypes[container].fillLevel+outputFillTypes[container][1].fillLevel;
				end;
				if outputFillTypes[container][1].productivity ~= nil then						
					separatedProductivity = true;					
					if tonumber(moGuiMiniPdaSlots.values[slot].productivity) >= tonumber(outputFillTypes[container][1].productivity) then
						moGuiMiniPdaSlots.values[slot].productivity = tonumber(outputFillTypes[container][1].productivity);
						moGuiMiniPdaSlots.values[slot].productivityColor = outputFillTypes[container][1].productivityColor;							
					end;
					if separated then 
						slotTableObject.productivity = tonumber(outputFillTypes[container][1].productivity);
					else
						slotTableObject.productivity = tonumber(slotTableObject.productivity)+(tonumber(outputFillTypes[container][1].productivity))/slotTableObject.length;
					end;
					slotTableObject.productivityColor = outputFillTypes[container][1].productivityColor;
					--if tonumber(slotTableObject.productivity) >= tonumber(outputFillTypes[container][1].productivity) then
					--	slotTableObject.productivity = tonumber(outputFillTypes[container][1].productivity);
					--	slotTableObject.productivityColor = outputFillTypes[container][1].productivityColor;
					--end;
				end;
				if slotTableObject.outputFillTypes[container].fillLevel > 0 then
					slotTableObject.lengthActive = slotTableObject.lengthActive+1;
					fillLevelFound = true;
				else
					slotTableObject.lengthNotActive = slotTableObject.lengthNotActive+1;
				end;
				--if slotTableObject.outputFillTypes[container].capacity < 0 then outputFillLevelIgnore = true;end;	
			end;				
		end;
		if not specialTable and inputFillTypes ~= nil and table.getn(inputFillTypes) > 0 then
			for container,info in pairs(inputFillTypes) do					
				if slotTableObject.inputFillTypes[container] == nil then
					slotTableObject.inputFillTypes[container] = {};						
					slotTableObject.inputFillTypes[container].capacity = inputFillTypes[container][1].capacity;
					slotTableObject.inputFillTypes[container].fillLevel = inputFillTypes[container][1].fillLevel;
					slotTableObject.inputFillTypes[container].bestPrice = inputFillTypes[container][1].pricePerLiter;
					slotTableObject.inputFillTypes[container].fillTypeName = inputFillTypes[container][1].fillTypeName;
					slotTableObject.inputFillTypes[container].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes;
					if inputFillTypes[container][1].setColor ~= nil then 
						slotTableObject.inputFillTypes[container].setColor = inputFillTypes[container][1].setColor;						
					end;
					
					if inputFillTypes[container][1].extraText ~= nil then slotTableObject.inputFillTypes[container].extraText = inputFillTypes[container][1].extraText;end;
					if inputFillTypes[container][1].fillTypeContainerName ~= nil then slotTableObject.inputFillTypes[container].fillTypeContainerName = inputFillTypes[container][1].fillTypeContainerName;end;
				else
					if inputFillTypes[container][1].capacity ~= -1 and inputFillTypes[container][1].capacity ~= -2 and inputFillTypes[container][1].capacity ~= -3 then						
						slotTableObject.inputFillTypes[container].capacity = slotTableObject.inputFillTypes[container].capacity+inputFillTypes[container][1].capacity;
					end;
					slotTableObject.inputFillTypes[container].fillLevel = slotTableObject.inputFillTypes[container].fillLevel+inputFillTypes[container][1].fillLevel;
				end;				
				if slotTableObject.inputFillTypes[container].fillLevel > 0 then						
					fillLevelFound = true;
				end;					
			end;			
		end;
		if not separated and slotTableObject.length > 1 then
			setProductivityColor(self, slotTableObject, slot);
		end;		
	end;
	
	if placeable then
		local x,y,z;
		if xmlModString == nil then			
			for k, v in pairs(objectTable) do				
				--if modType == "ls" then inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableGreenhouse(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;
				--if modType == "fs" then inputFillTypes, outputFillTypes = moSetGetInputOutputFs:getFs(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;
				--if modType == "upk" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpk(self, objectTable[k].base, category);x,y,z = getWorldTranslation(objectTable[k].base.rootNode);end;				
				--if modType == "other" then inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;				
				setGetInputOutputFillTypes(false, x, z);
			end;			
		elseif string.find(xmlModString, "heaptiptrigger") and modType == "other" then
			for key, values in pairs(g_currentMission.tipTriggers) do
				if values.configFileName ~= nil and string.lower(values.configFileName) == string.lower(MultiOverlayV2.gameDir.. xmlModString) then
					inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, values, category, xmlModString);
					x,y,z = getWorldTranslation(values.rootNode);
					setGetInputOutputFillTypes(false, x, z);
				end;
			end;
		elseif modType == "upk" then
			for key, values in pairs(objectTable) do
				if objectTable[key].xmlModString ~= nil and objectTable[key].xmlModString == xmlModString then 
					if objectTable[key].className == "aaa_universalprocesskit.placeableupk" then
						inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpk(self, objectTable[key].key.base, category);
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					end;					
				end;
			end;		
		elseif modType == "fs" then
			for key, values in pairs(objectTable) do
				if objectTable[key].xmlModString ~= nil and objectTable[key].xmlModString == xmlModString then --Saegewerk_placeable.FabrikScript
					if string.find(objectTable[key].className, "fabrikscript") then						
						inputFillTypes, outputFillTypes = moSetGetInputOutputFs:getFs(self, objectTable[key].key);
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					end;					
				end;
			end;
		elseif modType == "cf" then
			for key, values in pairs(objectTable) do
				if objectTable[key].xmlModString ~= nil and objectTable[key].xmlModString == xmlModString then --Saegewerk_placeable.mCompanyFactory					
					if string.find(objectTable[key].className, "mcompanyfactory") then						
						inputFillTypes, outputFillTypes = moSetGetInputOutputCf:getCf(self, objectTable[key].key);
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					end;					
				end;
			end;	
		elseif modType == "ls" or modType == "other" then --check New Placeables Default
			for key, values in pairs(objectTable) do				
				if objectTable[key].xmlModString ~= nil and objectTable[key].xmlModString == xmlModString then					
					if objectTable[key].key.storage ~= nil and objectTable[key].key.objectData == nil and objectTable[key].className ~= "greenhouseplaceable" then
						inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableStorage(self, objectTable[key].key);
						category = "factory"; --replace category
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					elseif objectTable[key].key.waterTankCapacity ~= nil and objectTable[key].className == "greenhouseplaceable" then
						inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableGreenhouse(self, objectTable[key].key);
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					elseif objectTable[key].key.tipTrigger ~= nil and objectTable[key].className == "heatingplantplaceable" then						
						inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableShop(self, objectTable[key].key);
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);	
					elseif string.find(objectTable[key].className, "storagehouse") and objectTable[key].key.objectData ~= nil and objectTable[key].key.storage ~= nil then
						inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable[key].key, category); 
						category = "factory"; --replace category
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);
					elseif string.find(objectTable[key].className, "enhancedchickens") then --and (string.find(objectTable[key].className, "chickensfarm") or string.find(objectTable[key].className, "chickenssingle")) then --fs17_enhancedchickens_placeable.enhancedchickens
						category = "animals"; --replace category
						inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable[key].key, category, xmlModString); 
						x,y,z = getWorldTranslation(objectTable[key].key.nodeId);
						setGetInputOutputFillTypes(false, x, z);	
					end;				
				end;
			end;
			--for key, values in pairs(g_currentMission.objectsToClassName) do --["data/placeables/greenhouses/greenhouse01.xml"]				
			--	if values == "GreenhousePlaceable" and string.find(xmlModString, "greenhouse") then
			--		if key.configFileName ~= nil and string.lower(key.configFileName) == string.lower(xmlModString) then
						--inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableGreenhouse(self, key);
						--x,y,z = getWorldTranslation(key.nodeId);
						--setGetInputOutputFillTypes(false, x, z);
			--		end;					
			--	end;
			--	if values == "SiloExtensionPlaceable" and string.find(xmlModString, "siloextensions") then					
			--		if key.configFileName ~= nil and string.lower(key.configFileName) == string.lower(xmlModString) then						
			--			inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceableSiloExtensions(self, key);
			--			category = "factory";
			--			x,y,z = getWorldTranslation(key.nodeId);
			--			setGetInputOutputFillTypes(false, x, z);
			--		end;					
			--	end;
			--end;
		end;
	else
		local x,y,z;
		if modType == "ls" and xmlModString ~= "heaps" then
			inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getAnimals(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "ls" and xmlModString == "heaps" then			
			inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getHeap(self, objectTable, xmlModString);
			--if objectTable.px ~= nil and objectTable.pz ~= nil then x = objectTable.px;z = objectTable.pz;end;			
			setGetInputOutputFillTypes(false);						
		elseif modType == "fs" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputFs:getFs(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "cf" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputCf:getCf(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);	
		elseif modType == "upk" and string.lower(objectTable.name) == xmlModString then			
			inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpk(self, objectTable, category);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "sr" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputSr:getSr(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;
			setGetInputOutputFillTypes(false);
		elseif modType == "other" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable, category);
			category = "factory"; --replace category
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;
			setGetInputOutputFillTypes(false);	
		end;		
	end;				
end;

local test = 0;
function moSetGetSlotObjects:getPlaceables(self, tableToClass)		
	for key, values in pairs(g_currentMission.objectsToClassName) do --["data/placeables/greenhouses/greenhouse01.xml"]
		if key.configFileName ~= nil then
			table.insert(tableToClass, {className=tostring(values:lower()), key=key, xmlModString=tostring(key.configFileName:lower())})		
			--print("className...".. tostring(values:lower()))
			--if string.find(values:lower(), "fs17_enhancedchickens_placeable.enhancedchickens") and test < 2 then				
			--	for key1, value1 in pairs(key) do
			--		print("...key und value ...".. tostring(key1).. "-----".. tostring(value1))
					
			--		if type (value1) == "table" then	
			--			for key2, value2 in pairs(value1) do
			--				print("key2 und value2 ...".. tostring(key2).. "-----".. tostring(value2))
			--				print("value2.....")
			--				print(tostring(MultiOverlayV2:tableToString(value2)));
			--			end;		
			--		end;
			--		if key1 == "Trough" then	
			--			for key2, value2 in pairs(value1) do
			--				print("objectData key2 und value2 ...".. tostring(key2).. "-----".. tostring(value2))							
			--				if type (value2) == "table" then
			--					for key3, value3 in pairs(value2) do
			--					print("key3 und value3 ...".. tostring(key3).. "-----".. tostring(value3))
			--					print("value2.....")
			--					end;													
			--				end;							
							--print(tostring(MultiOverlayV2:tableToString(value2)));
			--			end;		
			--		end;					
			--	end;
			--	test = test+1;
			--end;
		end;
	end;
	return tableToClass;
end;

function setProductivityColor(self, slotTableObject, slot)
	local ratio = slotTableObject.productivity;	
	slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['green'];
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
end;

function setProductivityColorOld(self, slotTableObject, slot, outputFillLevelIgnore)		
	local outputCapacity = 0;
	local outputFillLevel = 0;
	local inputCapacity = 0;
	local inputFillLevel = 0;
	local input = false;
	local output = false;
	local noProductivity = false;
	local ratio = 0;
	if slotTableObject.outputFillTypes ~= nil and table.getn(slotTableObject.outputFillTypes) > 0 and not outputFillLevelIgnore then
		for container=1, table.getn(slotTableObject.outputFillTypes) do
			if slotTableObject.outputFillTypes[container] ~= nil and slotTableObject.outputFillTypes[container].fillLevel ~= nil and slotTableObject.outputFillTypes[container].capacity ~= nil then
				outputCapacity = outputCapacity+slotTableObject.outputFillTypes[container].capacity;
				outputFillLevel = outputFillLevel+slotTableObject.outputFillTypes[container].fillLevel;
				output = true;
			end;
		end;
	end;
	if slotTableObject.inputFillTypes ~= nil and table.getn(slotTableObject.inputFillTypes) > 0 then
		for container=1, table.getn(slotTableObject.inputFillTypes) do
			if slotTableObject.inputFillTypes[container] ~= nil and slotTableObject.inputFillTypes[container].fillLevel ~= nil and slotTableObject.inputFillTypes[container].capacity ~= nil then
				inputCapacity = inputCapacity+slotTableObject.inputFillTypes[container].capacity;
				inputFillLevel = inputFillLevel+slotTableObject.inputFillTypes[container].fillLevel;
				input = true;
			end;
		end;
	end;	
	if output then
		ratio = string.format("%0.0f", Utils.getNoNil(outputFillLevel/outputCapacity*100, 0));
		if tonumber(outputFillLevel) >= tonumber(outputCapacity) then			
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['redDisabled'];
			slotTableObject.productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
		else
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['redDisabled'];
			slotTableObject.productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
		end;
	end;	
	if input and not noProductivity then
		ratio = string.format("%0.0f", Utils.getNoNil(inputFillLevel/inputCapacity*100, 0));
		slotTableObject.productivity = ratio;	
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['green'];
		if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
		elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
		elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
		elseif tonumber(ratio) < 25 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
		end;
	end;
	if tonumber(moGuiMiniPdaSlots.values[slot].productivity) >= tonumber(ratio) then
		moGuiMiniPdaSlots.values[slot].productivity = tonumber(ratio);	
	end;	
end;